import com.allied.pgmex.pgmexec;
%
%% UNCOMMENT AND EDIT PARAMETERS IN ANGLE BRACKETS
% dbConn=com.allied.pgmex.pgmexec('connect',['host=<myHos> user=<myUser>',...
%    port=<myPort> password=<myPassword> dbname=<myDB>'])
%
%% create schema and table
pgmexec('exec',dbConn,'CREATE SCHEMA IF NOT EXISTS demo');
pgmexec('exec',dbConn,'DROP TABLE IF EXISTS demo.demo_table');
pgResult=pgmexec('exec',dbConn,['CREATE TABLE IF NOT EXISTS demo.demo_table ('...
    't_date date,'...
    'exp_name varchar(40),'...
    'exp_conf xml,'...
    'exp_t_vec timestamp[],'...
    'exp_col_name_vec name[],'...
    'exp_res_mat float8[])'])% pgResult=uint64(3740775088)
%
%% get status of execution result (all is successful)
pgmexec('resultStatus',pgResult)% ans = 1
%% command executed
pgmexec('cmdStatus',pgResult)% ans= 'CREATE TABLE'
%% clear result
pgmexec('clear',pgResult)
%% insert the first tuple into the table and get it as text
% create parameters structure
pgParam=pgmexec('paramCreate',dbConn)% pgParam =uint64(3843492816)
%% set parameters
pgmexec('putf',pgParam,...
    '%date %varchar %xml %timestamp[]@ %name[]@ %float8[]',...
    datenum('1-Dec-2016'),'Experiment #1',[...
    '<conf>'...
	'<model type="struct" >'...
	'	<param1 type="double" >1</param1>'...
    '   <param2 type="boolean" >false</param2>'...
    '</model>'...
    '</conf>'],...
    [datenum('0:00:00');datenum('0:00:10');datenum('0:01:30')],...
    {'res1','res2'},...
    struct('valueMat',{[NaN 2.4;-2 Inf;0 NaN]},...
    'isNullMat',{[true false;false false;true false]},...
    'isValueNull',false));
%
%% get number of parameters set
nParams=pgmexec('paramCount',pgParam)% nParams =int32(6)
%% insert the correspoding tuple into the table
pgResult=pgmexec('paramExec',dbConn,pgParam,...
    'INSERT INTO demo.demo_table values ($1, $2, $3, $4, $5, $6)')
%
% pgResult =uint64(3849603824)
%
%% get result status (all is successful)
pgmexec('resultStatus',pgResult)% ans = 1 (COMMAND_OK)
%% get command info and the number of tuples affected
pgmexec('cmdStatus',pgResult)
%
% ans = 'INSERT 0 1' (one record inserted, OID=0 as tables do not have OID)
%
%%
pgmexec('cmdTuples',pgResult)% ans='1' (one tuple affected by the command)
%% clear the result
pgmexec('clear',pgResult)
%% get the inserted tuple
pgResult=pgmexec('pqexec',dbConn,'SELECT * FROM  demo.demo_table')
% pgResult=uint64(3849610992)
%
%% check that the returned result is not binary
pgmexec('binaryTuples',pgResult)% ans=false
%% get result status (tuples are returned)
pgmexec('resultStatus',pgResult)% ans=2 (TUPLES_OK)
%
%% check pgResult
pgmexec('cmdStatus',pgResult)% ans='SELECT 1'
pgmexec('cmdTuples',pgResult)% ans='1' (one tuple affected by the command)
pgmexec('nFields',pgResult)% ans=6
pgmexec('nTuples',pgResult)% ans=1
pgmexec('fName',pgResult,0)% ans='t_date'
pgmexec('fNumber',pgResult,'exp_name')% ans=1
%
%% try to determine index of nonexistent field
pgmexec('fNumber',pgResult,'not_exp_field')% ans=-1
%% get size of field
pgmexec('fSize',pgResult,0)% ans=4
%% get length, value of field and tuple along with info whether it is null
%% or not
pgmexec('getLength',pgResult,0,5)% ans=37
pgmexec('getValue',pgResult,0,5)% {{NULL,2.4},{-2,Infinity},{NULL,NaN}}
pgmexec('getIsNull',pgResult,0,5)% ans=false
%%
%% clear the results
pgmexec('clear',pgResult) %#ok<*NOPTS>